#pragma once

#include "kernel/systemobject.h"
#include "kernel/xregistrykey.h"

// 
#include "Uniteller.Framework.Kernel.h"
#include "Uniteller.Framework.Kernel.Host.h"
#include "Uniteller.CrossroadController.h"

using namespace Uniteller::Framework::Kernel;

namespace Uniteller
{
  namespace CrossroadController
  {

        /// <summary>
        ///   
        /// </summary>
        class Machine : public SystemObject<Machine, ISystemObject>
        {
        public:
          //     
          BEGIN_HANDLERS_MAP()

            REGISTER_HANDLER("Idle", "Idle", Framework::Kernel::Protocol::G1::Codes::Start,  &Machine::StartHandler);

          END_HANDLERS_MAP()
        public:
          Machine(IKernelApi * api) : SystemObject<Machine, ISystemObject>("Uniteller.CrossroadController", api)            
          {
          }
          ~Machine();
        private: //            
          //USE_PROTOCOL(Uniteller::Framework::Kernel::Host, 1, Host);

          IMPLEMENT_PROTOCOL(Uniteller::CrossroadController, 1, Protocol);

          /// <summary>
          ///    (       )
          /// </summary>         
          BEGIN_ENDPOINTS()
            PROTOCOL_ENDPOINT(Protocol, GetUnicalId());

            //m_Host.SetModuleId("master", this);     
          END_ENDPOINTS()

        protected: //   
          DECLARE_HANDLER(StartHandler, Framework::Kernel::Protocol::G1::Start);
          void MachineInitErrorHandlerSystem(IMessage * message);
          //DECLARE_HANDLER(IsExistsHandler, Protocol::G1::IsExists);
          //DECLARE_HANDLER(CleanUpHandler, Protocol::G1::CleanUp);


        private: //  
          

        private: //   
          /// <summary>
          ///  
          /// </summary>
          void Clear();

        };

  } //   ComponentBuilder
} //   Uniteller
